<CsoundSynthesizer>
<CsOptions>
</CsOptions>
<CsInstruments>

sr=96000 
ksmps=1
nchnls=2
0dbfs=1



giEQ1	ftgen 1000,0,8192,-7,1,8192, 1 
giEQ2	ftgen 1001,0,8192,-7,1,8192, 1 

; Filename           # ??? #  ; Name of file to process.  Required parameter,


# ifndef Fftsize                    
# define Fftsize          # 2048 #  
# end

# ifndef Ol
# define Ol               # 4 #  
# end

# ifndef Win
# define Win  		      # 2 #  
# end

# ifndef Wt
# define Wt	              # 0 #
# end

# ifndef sp
# define sp	              # 1 #
# end

	opcode pvsEQ, 0, iiii

; our input values are:
; kpitch - pitch shift amount [.5=down octave,
; 1=noshift, 2=up octave, etc]
; kstretch - spectral shift amount [ususal range is
; .99-1.01, where 1=nostretch]
; inumbins - number of fft bins [size of tables]
; iampin - table containing amp data
; iampout - table to write modified amp data
; ifreqin - table containing freq data
; ifreqout - table to write modified freq data

inumbins, iampin, iampout, iEQ xin

; make sure we start with an empty table
iclear 	ftgen 0, 0, inumbins, 2, 0
	tablecopy iampout, iclear
; perform a do-while loop, cycling through the tables and shifting pitch
kcount = 0
loop:

if (kcount < inumbins) then

kval 	table kcount, iampin
kEQ 	table kcount, iEQ
		tablew kval*(kEQ+0.0000001), kcount, iampout

endif

kcount = kcount+1

if (kcount < inumbins) kgoto loop


endop


instr Setup
	ilength   filelen "$Filename"            ; Length of file in seconds

	; Process audio file

	event_i "i", 1, 0, (ilength / $sp) +.3
	turnoff
endin

	
instr 1
ftload "./EQ/EQ1.ftsave", 1, 1000
ftload "./EQ/EQ2.ftsave", 1, 1001
	

ifilesr filesr "$Filename" 
ain1, ain2     diskin2 "$Filename", $sp  ; Read file from disk

ain1	delay ain1, .1
ain2	delay ain2, .1

 	denorm	ain1, ain2

ain1 dcblock2 ain1
ain2 dcblock2 ain2

; get input and do pvanal

ifftsize = $Fftsize
iol = $Ol
iNumBins = (ifftsize/2) + 1
ihop = ifftsize/iol
iwindow = ifftsize * $Win

	
fsig1 pvsanal ain1, ifftsize, ihop, iwindow, $Wt
fsig2 pvsanal ain2, ifftsize, ihop, iwindow, $Wt

idel=iwindow/sr
aout3	delay ain1,idel 
aout4	delay ain2,idel


iampin1 ftgen 0,0,iNumBins,2,0
iampout1 ftgen 0,0,iNumBins,2,0

iampin2 ftgen 0,0,iNumBins,2,0
iampout2 ftgen 2000,0,iNumBins,2,0


; export fsig to tables
kflag pvsftw fsig1, iampin1
if (kflag > 0) then ; only proc when frame is ready

; pitch shift/stretch
	pvsEQ	iNumBins, iampin1, iampout1,giEQ1

; read modified data back to fsrc
	pvsftr fsig1, iampout1

endif


; export fsig to tables
kflag2 pvsftw fsig2, iampin2
if (kflag2 > 0) then ; only proc when frame is ready

; pitch shift/stretch
	pvsEQ	iNumBins, iampin2, iampout2,giEQ2
; read modified data back to fsrc
	pvsftr fsig2, iampout2

endif

aout1 pvsynth fsig1
aout2 pvsynth fsig2


outs (aout1*1)+(aout3*0), (aout2*1)+(aout4*0)

endin	

	
	
</CsInstruments>
<CsScore>

i "Setup" 0 0.0001  ; Start processor

e

</CsScore>
</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 943 62 200 494
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>
<MacGUI>
ioView nobackground {65535, 65535, 65535}
ioSlider {5, 5} {20, 100} 0.000000 1.000000 0.000000 slider1
ioSlider {45, 5} {20, 100} 0.000000 1.000000 0.000000 slider2
ioSlider {85, 5} {20, 100} 0.000000 1.000000 0.000000 slider3
ioSlider {125, 5} {20, 100} 0.000000 1.000000 0.000000 slider4
ioSlider {165, 5} {20, 100} 0.000000 1.000000 0.000000 slider5
</MacGUI>

